#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <io.h>
#include <process.h>
#include <fcntl.h>
#include <share.h>
#include <sys/stat.h>
//#include <sys/types.h>
#include "../myinc/stderr.h"

int SearchSlot(int isStartNo, char *lpszFileName) {

    int rCode, count=isStartNo;
    long lsFindFile;
    struct _finddata_t struFileInfo;

    for(lsFindFile=_findfirst(lpszFileName,&struFileInfo);count<99999999,lsFindFile!=-1;++count) {
        rCode=atoi(struFileInfo.name);
        if(count>rCode) 
            --count;
        else 
            count=rCode;
        if( (_findnext(lsFindFile, &struFileInfo)) == -1) {
            _findclose(lsFindFile);
            lsFindFile=-1;
        }
    }
    return count;
}    

main(int argc, char *argv[]) {
    int isSTDIOhandles[2];
    char szWRKFileName[13], szTXTFileName[13];
    int isInStreamHandle, isOutStreamHandle;
    long lsFileSize;
    char *szDomain=NULL, *szMailFrom=NULL, *szMailTo=NULL;
    int count;
    int rCode;
    int isLastMailSlot;
    char *ptr;

    // Save original I/O handlers contexts
    isSTDIOhandles[0]=_dup(0);
    isSTDIOhandles[1]=_dup(1);

    sprintf(szWRKFileName,"*.%s","WRK");
    isLastMailSlot=SearchSlot(1,szWRKFileName);
    sprintf(szTXTFileName,"*.%s","TXT");
    isLastMailSlot=SearchSlot(isLastMailSlot,szTXTFileName);
 
    if( isatty(0) ) {

        for(count=isInStreamHandle=0,isOutStreamHandle=1;count<isLastMailSlot;count++) {

            sprintf(szWRKFileName,"%08d.%s",count,"WRK");
            sprintf(szTXTFileName,"%08d.%s",count,"TXT");

            if(isInStreamHandle!=EXIT_ERROR) 
                rCode=_close(isInStreamHandle);
            isInStreamHandle=_open(szWRKFileName,_O_RDONLY|_O_TEXT);
            if(isInStreamHandle==EXIT_ERROR) 
                continue;
            lsFileSize=_filelength(isInStreamHandle);
            if(lsFileSize==0 || lsFileSize==-1) 
                continue;
            if( (szDomain=realloc(szDomain,++lsFileSize)) == NULL) 
                continue;
            memset(szDomain, 0, lsFileSize--);
            rCode=_read(isInStreamHandle, szDomain, (unsigned int)lsFileSize);
            for(ptr=szDomain,rCode=0;rCode<lsFileSize;rCode++,ptr++)
                if(isspace(*ptr)) 
                    break;
            *(ptr++)='\0';
            lsFileSize-=strlen(szDomain);
            if( (szMailFrom=realloc(szMailFrom,++lsFileSize)) == NULL) 
                continue;
            memcpy(szMailFrom, ptr, lsFileSize);
            for(ptr=szMailFrom,rCode=0;rCode<lsFileSize;rCode++,ptr++)
                if(isspace(*ptr)) 
                    break;
            *(ptr++)='\0';
            lsFileSize-=strlen(szMailFrom);
            if( (szMailTo=realloc(szMailTo,++lsFileSize)) == NULL) 
                continue;
            memcpy(szMailTo, ptr, lsFileSize);
            for(ptr=szMailTo,rCode=0;rCode<lsFileSize;rCode++,ptr++)
                if(isspace(*ptr)) 
                    break;
            *ptr='\0';
            if(*szDomain=='\0') 
                continue;
            if(*szMailFrom=='\0') 
                continue;
            if(*szMailTo=='\0') 
                continue;
            if( (strchr(szMailFrom,'@')) == NULL) {
                if( (ptr=malloc(2+strlen(szDomain)+strlen(szMailFrom))) == NULL) 
                    continue;
                sprintf(ptr,"%s@%s",szMailFrom,szDomain);
                free(szMailFrom);
                szMailFrom=ptr;
            }
            if( (strchr(szMailTo,'@')) == NULL) {
                if( (ptr=malloc(2+strlen(szDomain)+strlen(szMailTo))) == NULL) 
                    continue;
                sprintf(ptr,"%s@%s",szMailTo,szDomain);
                free(szMailTo);
                szMailTo=ptr;
            }


            if(isInStreamHandle!=EXIT_ERROR) 
                rCode=_close(isInStreamHandle);
            isInStreamHandle=_open(szTXTFileName,_O_RDONLY|_O_TEXT);
            if(isInStreamHandle==EXIT_ERROR) 
                continue;

            rCode=_spawnlp( _P_WAIT, "sendmail", "sendmail", szDomain, szMailTo, szMailFrom, NULL );
            if(rCode!=0) 
                continue;

            if(isInStreamHandle!=EXIT_ERROR) 
                rCode=_close(isInStreamHandle);
            rCode=_unlink(szWRKFileName);
            rCode=_unlink(szTXTFileName);
        }
    } else for (count=isInStreamHandle=0,isOutStreamHandle=1;count<isLastMailSlot;count++) {

        count=isLastMailSlot;
        isLastMailSlot=0;

        sprintf(szWRKFileName,"%08d.%s",count,"WRK");
        sprintf(szTXTFileName,"%08d.%s",count,"TXT");

        if(isOutStreamHandle!=EXIT_ERROR) 
            rCode=_close(isOutStreamHandle);

        for(count=1, rCode='T';count<argc;++count) {
            if( *(ptr=argv[count])=='-') 
                rCode=toupper(*(++ptr));
            else {
                switch(rCode) {
                    case 'F':
                    szMailFrom=_strdup(ptr);
                    break;
                    case 'D':
                    szDomain=_strdup(ptr);
                    break;
                    default:
                    szMailTo=_strdup(ptr);
                }
                rCode='T';
            }
        }

        if(*szDomain=='\0') 
            continue;
        if(*szMailFrom=='\0') 
            continue;
        if(*szMailTo=='\0') 
            continue;
        lsFileSize=strlen(szDomain);
        if( (strchr(szMailFrom,'@')) == NULL) {
            if( (ptr=malloc(2+strlen(szDomain)+strlen(szMailFrom))) == NULL) 
                continue;
            sprintf(ptr,"%s@%s",szMailFrom,szDomain);
            free(szMailFrom);
            szMailFrom=ptr;
        }
        lsFileSize+=strlen(szMailFrom);
        if( (strchr(szMailTo,'@')) == NULL) {
            if( (ptr=malloc(2+strlen(szDomain)+strlen(szMailTo))) == NULL) 
                continue;
            sprintf(ptr,"%s@%s",szMailTo,szDomain);
            free(szMailTo);
            szMailTo=ptr;
        }
        lsFileSize+=strlen(szMailTo);

        if( (ptr=malloc(lsFileSize+=4)) == NULL)
            continue;
        sprintf(ptr,"%s\n%s\n%s\n",szDomain,szMailFrom,szMailTo);
        isOutStreamHandle=_open(szWRKFileName,_O_CREAT|_O_WRONLY|_O_TEXT,_S_IFREG|_S_IWRITE);
        //_fmode
        //_chmode
        //_access
        //_sopen
// _S_IREAD
 //_S_IWRITE
        if(isOutStreamHandle==EXIT_ERROR) 
            continue;
/*
        {
            isOutStreamHandle=_open(szWRKFileName,_O_APPEND|_O_TEXT);
            if(isOutStreamHandle==EXIT_ERROR)
                continue;
        }
*/
        rCode=_write(isOutStreamHandle, ptr, (unsigned int)(--lsFileSize));
        rCode=_commit(isOutStreamHandle);
        
        if(isOutStreamHandle!=EXIT_ERROR) 
            rCode=_close(isOutStreamHandle);
        isOutStreamHandle=_open(szTXTFileName,_O_CREAT|_O_WRONLY|_O_TEXT,_S_IFREG|_S_IWRITE);
        if(isOutStreamHandle==EXIT_ERROR) 
            continue;
        if( (ptr=realloc(ptr,2048)) == NULL)
            continue;
        do {
            lsFileSize=_read(isInStreamHandle, ptr, 2048);
            rCode=_write(isOutStreamHandle, ptr, (unsigned int)lsFileSize);
            rCode=_commit(isOutStreamHandle);
        } while(!_eof(isInStreamHandle));
        if(isOutStreamHandle!=EXIT_ERROR) 
            rCode=_close(isOutStreamHandle);
        free(ptr);
    }

    szDomain=realloc(szDomain,0);
    szMailFrom=realloc(szMailFrom,0);
    szMailTo=realloc(szMailTo,0);

    // Restore original I/O handlers contexts
    rCode=_dup2(0,isSTDIOhandles[0]);
    rCode=_dup2(1,isSTDIOhandles[1]);

	return EXIT_SUCCESS;
}
